]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
Added support for rotated outputs to the xrandr codepath.
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devices
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by default, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 XDPYINFO=/usr/bin/xdpyinfo
50 PROFILES=~/.autorandr/
51 CONFIG=~/.autorandr.conf
52
53 CHANGE_PROFILE=0
54 FORCE_LOAD=0
55 DEFAULT_PROFILE=""
56 SAVE_PROFILE=""
57
58 FP_METHODS="setup_fp_xrandr_edid setup_fp_sysfs_edid"
59 CURRENT_CFG_METHOD="current_cfg_xrandr"
60 LOAD_METHOD="load_cfg_xrandr"
61
62 SCRIPTNAME="$(basename $0)"
63 # when called as autodisper/auto-disper, we assume different defaults
64 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
65         echo "Assuming disper defaults..." >&2
66         FP_METHODS="setup_fp_disper"
67         CURRENT_CFG_METHOD="current_cfg_disper"
68         LOAD_METHOD="load_cfg_disper"
69 fi
70
71 if [ -f $CONFIG ]; then
72         echo "Loading configuration from '$CONFIG'" >&2
73         . $CONFIG
74 fi
75
76 setup_fp_xrandr_edid() {
77         $XRANDR -q --verbose | awk '
78         /^[^ ]+ (dis)?connected / { DEV=$1; }
79         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
80         END { for (X in ID) { print X " " ID[X]; } }'
81 }
82
83 setup_fp_sysfs_edid() {
84         # xrandr triggers the reloading of EDID data
85         $XRANDR -q > /dev/null
86         # hash the EDIDs of all _connected_ devices
87         for P in /sys/class/drm/card*-*/; do
88                 # nothing found
89                 [ ! -d "$P" ] && continue
90                 if grep -q "^connected$" < "${P}status"; then
91                         echo -n "$(basename "$P") "
92                         md5sum ${P}edid | awk '{print $1}'
93                 fi
94         done
95 }
96
97 setup_fp_disper() {
98         $DISPER -l | grep '^display '
99 }
100
101 setup_fp() {
102         local FP="";
103         for M in $FP_METHODS; do
104                 FP="$($M)"
105                 if [ -n "$FP" ]; then
106                         break
107                 fi
108         done
109         if [ -z "$FP" ]; then
110                 echo "Unable to fingerprint display configuration" >&2
111                 return
112         fi
113         echo "$FP"
114 }
115
116 current_cfg_xrandr() {
117         local PRIMARY_SETUP="";
118         if [ -x "$XDPYINFO" ]; then
119                 PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
120         fi
121         $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
122         # display is connected and has a mode
123         /^[^ ]+ connected [^(]/ {
124                 split($3, A, "+");
125                 print "output "$1;
126                 if (($4 == "left") || ($4 == "right")) {
127                         split(A[1], B, "x");
128                         A[1] = B[2]"x"B[1];
129                         print "rotate "$4;
130                 }
131                 print "mode "A[1];
132                 print "pos "A[2]"x"A[3];
133                 if (A[1] A[2] "," A[3] == primary_setup)
134                         print "primary";
135                 next;
136         }
137         # disconnected or disabled displays
138         /^[^ ]+ (dis)?connected / ||
139         /^[^ ]+ unknown connection / {
140                 print "output "$1;
141                 print "off";
142                 next;
143         }'
144 }
145
146 current_cfg_disper() {
147         $DISPER -p
148 }
149
150 current_cfg() {
151         $CURRENT_CFG_METHOD;
152 }
153
154 blocked() {
155         local PROFILE="$1"
156         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
157
158         "$PROFILES/$PROFILE/block" "$PROFILE"
159 }
160
161 config_equal() {
162         local PROFILE="$1"
163         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
164                 echo "Config already loaded"
165                 return 0
166         else
167                 return 1
168         fi
169 }
170
171 load_cfg_xrandr() {
172         sed 's!^!--!' "$1" | xargs $XRANDR
173 }
174
175 load_cfg_disper() {
176         $DISPER -i < "$1"
177 }
178
179 load() {
180         local PROFILE="$1"
181         local CONF="$PROFILES/$PROFILE/config"
182         if [ -e "$CONF" ] ; then
183                 echo " -> loading profile $PROFILE"
184                 $LOAD_METHOD "$CONF"
185
186                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
187                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
188                 [ -x "$PROFILES/postswitch" ] && \
189                         "$PROFILES/postswitch" "$PROFILE"
190         fi
191 }
192
193 help() {
194         cat <<EOH
195 Usage: $SCRIPTNAME [options]
196
197 -h, --help              get this small help
198 -c, --change            reload current setup
199 -s, --save <profile>    save your current setup to profile <profile>
200 -l, --load <profile>    load profile <profile>
201 -d, --default <profile> make profile <profile> the default profile
202 --force                 force (re)loading of a profile
203 --fingerprint           fingerprint your current hardware setup
204
205  To prevent a profile from being loaded, place a script call "block" in its
206  directory. The script is evaluated before the screen setup is inspected, and
207  in case of it returning a value of 0 the profile is skipped. This can be used
208  to query the status of a docking station you are about to leave.
209
210  If no suitable profile can be identified, the current configuration is kept.
211  To change this behaviour and switch to a fallback configuration, specify
212  --default <profile>.
213
214  Another script called "postswitch "can be placed in the directory
215  ~/.autorandr as well as in any profile directories: The scripts are executed
216  after a mode switch has taken place and can notify window managers.
217
218  When called by the name "autodisper" or "auto-disper", the script uses "disper"
219  instead of "xrandr" to detect, configure and save the display configuration.
220
221 EOH
222         exit
223 }
224 # process parameters
225 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,help -- "$@")
226 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
227 eval set -- "$OPTS"
228
229 while true; do
230         case "$1" in
231                 -c|--change) CHANGE_PROFILE=1; shift ;;
232                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
233                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
234                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
235                 -h|--help) help ;;
236                 --force) FORCE_LOAD=1; shift ;;
237                 --fingerprint) setup_fp; exit 0;;
238                 --) shift; break ;;
239                 *) echo "Error: $1"; exit 1;;
240         esac
241 done
242
243 CURRENT_SETUP="$(setup_fp)"
244
245 if [ -n "$SAVE_PROFILE" ]; then
246         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
247         mkdir -p "$PROFILES/$SAVE_PROFILE"
248         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
249         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
250         exit 0
251 fi
252
253 if [ -n "$LOAD_PROFILE" ]; then
254         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
255         exit $?
256 fi
257
258 for SETUP_FILE in $PROFILES/*/setup; do
259         if ! [ -e $SETUP_FILE ]; then
260                 break
261         fi
262         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
263         echo -n "$PROFILE"
264
265         if blocked "$PROFILE"; then
266                 echo " (blocked)"
267                 continue
268         fi
269
270         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
271         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
272                 echo " (detected)"
273                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
274                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
275                                 load "$PROFILE"
276                         fi
277                 fi
278                 # found the profile, exit with success
279                 exit 0
280         else
281                 echo ""
282         fi
283 done
284
285 # we did not find the profile, load default
286 if [ -n "$DEFAULT_PROFILE" ]; then
287         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
288         load "$DEFAULT_PROFILE"
289 fi
290 exit 1